import { Signer } from "ethers";
import { Provider, TransactionRequest } from "@ethersproject/providers";
import { ContractFactory, Overrides } from "@ethersproject/contracts";
import type { Avatar } from "./Avatar";
export declare class AvatarFactory extends ContractFactory {
    constructor(signer?: Signer);
    deploy(avatarExchangeContractAddr: string, overrides?: Overrides): Promise<Avatar>;
    getDeployTransaction(avatarExchangeContractAddr: string, overrides?: Overrides): TransactionRequest;
    attach(address: string): Avatar;
    connect(signer: Signer): AvatarFactory;
    static connect(address: string, signerOrProvider: Signer | Provider): Avatar;
}
