/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
} from "ethers";
import {
  Contract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "@ethersproject/contracts";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";

interface ISpaceInterface extends ethers.utils.Interface {
  functions: {
    "acceptBid(uint256,tuple)": FunctionFragment;
    "checkLandAttach(uint256,address)": FunctionFragment;
    "listTransfer(uint256,address)": FunctionFragment;
    "mint(tuple,tuple)": FunctionFragment;
    "removeAsk(uint256)": FunctionFragment;
    "removeBid(uint256)": FunctionFragment;
    "revokeApproval(uint256)": FunctionFragment;
    "setAsk(uint256,tuple)": FunctionFragment;
    "setBid(uint256,tuple)": FunctionFragment;
    "tokenMetadataURI(uint256)": FunctionFragment;
    "updateTokenLands(uint256,uint256[])": FunctionFragment;
    "updateTokenMetadataURI(uint256,string)": FunctionFragment;
    "updateTokenURI(uint256,string)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "acceptBid",
    values: [
      BigNumberish,
      {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "checkLandAttach",
    values: [BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "listTransfer",
    values: [BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "mint",
    values: [
      {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "removeAsk",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "removeBid",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "revokeApproval",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "setAsk",
    values: [BigNumberish, { amount: BigNumberish; currency: string }]
  ): string;
  encodeFunctionData(
    functionFragment: "setBid",
    values: [
      BigNumberish,
      {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      }
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "tokenMetadataURI",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "updateTokenLands",
    values: [BigNumberish, BigNumberish[]]
  ): string;
  encodeFunctionData(
    functionFragment: "updateTokenMetadataURI",
    values: [BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "updateTokenURI",
    values: [BigNumberish, string]
  ): string;

  decodeFunctionResult(functionFragment: "acceptBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "checkLandAttach",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "listTransfer",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "mint", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "removeAsk", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "removeBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "revokeApproval",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setAsk", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setBid", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "tokenMetadataURI",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updateTokenLands",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updateTokenMetadataURI",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updateTokenURI",
    data: BytesLike
  ): Result;

  events: {
    "TokenLandsUpdated(uint256,address,uint256[])": EventFragment;
    "TokenMetadataURIUpdated(uint256,address,string)": EventFragment;
    "TokenURIUpdated(uint256,address,string)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "TokenLandsUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "TokenMetadataURIUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "TokenURIUpdated"): EventFragment;
}

export class ISpace extends Contract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  on(event: EventFilter | string, listener: Listener): this;
  once(event: EventFilter | string, listener: Listener): this;
  addListener(eventName: EventFilter | string, listener: Listener): this;
  removeAllListeners(eventName: EventFilter | string): this;
  removeListener(eventName: any, listener: Listener): this;

  interface: ISpaceInterface;

  functions: {
    acceptBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "acceptBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    checkLandAttach(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<{
      0: boolean;
    }>;

    "checkLandAttach(uint256,address)"(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<{
      0: boolean;
    }>;

    listTransfer(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "listTransfer(uint256,address)"(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    mint(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "mint(tuple,tuple)"(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    removeAsk(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    removeBid(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "removeBid(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    revokeApproval(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "revokeApproval(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "setAsk(uint256,tuple)"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "setBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    tokenMetadataURI(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<{
      0: string;
    }>;

    "tokenMetadataURI(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<{
      0: string;
    }>;

    updateTokenLands(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "updateTokenLands(uint256,uint256[])"(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    updateTokenMetadataURI(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "updateTokenMetadataURI(uint256,string)"(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    updateTokenURI(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: Overrides
    ): Promise<ContractTransaction>;

    "updateTokenURI(uint256,string)"(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: Overrides
    ): Promise<ContractTransaction>;
  };

  acceptBid(
    tokenId: BigNumberish,
    bid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "acceptBid(uint256,tuple)"(
    tokenId: BigNumberish,
    bid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  checkLandAttach(
    tokenId: BigNumberish,
    sender: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  "checkLandAttach(uint256,address)"(
    tokenId: BigNumberish,
    sender: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  listTransfer(
    tokenId: BigNumberish,
    recipient: string,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "listTransfer(uint256,address)"(
    tokenId: BigNumberish,
    recipient: string,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  mint(
    data: {
      tokenURI: string;
      metadataURI: string;
      contentHash: BytesLike;
      metadataHash: BytesLike;
      isPublic: boolean;
      lands: BigNumberish[];
    },
    bidShares: {
      prevOwner: { value: BigNumberish };
      creator: { value: BigNumberish };
      owner: { value: BigNumberish };
    },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "mint(tuple,tuple)"(
    data: {
      tokenURI: string;
      metadataURI: string;
      contentHash: BytesLike;
      metadataHash: BytesLike;
      isPublic: boolean;
      lands: BigNumberish[];
    },
    bidShares: {
      prevOwner: { value: BigNumberish };
      creator: { value: BigNumberish };
      owner: { value: BigNumberish };
    },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  removeAsk(
    tokenId: BigNumberish,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "removeAsk(uint256)"(
    tokenId: BigNumberish,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  removeBid(
    tokenId: BigNumberish,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "removeBid(uint256)"(
    tokenId: BigNumberish,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  revokeApproval(
    tokenId: BigNumberish,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "revokeApproval(uint256)"(
    tokenId: BigNumberish,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  setAsk(
    tokenId: BigNumberish,
    ask: { amount: BigNumberish; currency: string },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "setAsk(uint256,tuple)"(
    tokenId: BigNumberish,
    ask: { amount: BigNumberish; currency: string },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  setBid(
    tokenId: BigNumberish,
    bid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "setBid(uint256,tuple)"(
    tokenId: BigNumberish,
    bid: {
      amount: BigNumberish;
      currency: string;
      bidder: string;
      recipient: string;
      sellOnShare: { value: BigNumberish };
    },
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  tokenMetadataURI(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<string>;

  "tokenMetadataURI(uint256)"(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<string>;

  updateTokenLands(
    tokenId: BigNumberish,
    lands: BigNumberish[],
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "updateTokenLands(uint256,uint256[])"(
    tokenId: BigNumberish,
    lands: BigNumberish[],
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  updateTokenMetadataURI(
    tokenId: BigNumberish,
    metadataURI: string,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "updateTokenMetadataURI(uint256,string)"(
    tokenId: BigNumberish,
    metadataURI: string,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  updateTokenURI(
    tokenId: BigNumberish,
    tokenURI: string,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  "updateTokenURI(uint256,string)"(
    tokenId: BigNumberish,
    tokenURI: string,
    overrides?: Overrides
  ): Promise<ContractTransaction>;

  callStatic: {
    acceptBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    "acceptBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    checkLandAttach(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    "checkLandAttach(uint256,address)"(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    listTransfer(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: CallOverrides
    ): Promise<void>;

    "listTransfer(uint256,address)"(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: CallOverrides
    ): Promise<void>;

    mint(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    "mint(tuple,tuple)"(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    removeAsk(tokenId: BigNumberish, overrides?: CallOverrides): Promise<void>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    removeBid(tokenId: BigNumberish, overrides?: CallOverrides): Promise<void>;

    "removeBid(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    revokeApproval(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    "revokeApproval(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: CallOverrides
    ): Promise<void>;

    "setAsk(uint256,tuple)"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: CallOverrides
    ): Promise<void>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    "setBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: CallOverrides
    ): Promise<void>;

    tokenMetadataURI(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<string>;

    "tokenMetadataURI(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<string>;

    updateTokenLands(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: CallOverrides
    ): Promise<void>;

    "updateTokenLands(uint256,uint256[])"(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: CallOverrides
    ): Promise<void>;

    updateTokenMetadataURI(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: CallOverrides
    ): Promise<void>;

    "updateTokenMetadataURI(uint256,string)"(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: CallOverrides
    ): Promise<void>;

    updateTokenURI(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: CallOverrides
    ): Promise<void>;

    "updateTokenURI(uint256,string)"(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    TokenLandsUpdated(
      _tokenId: BigNumberish | null,
      owner: null,
      lands: null
    ): EventFilter;

    TokenMetadataURIUpdated(
      _tokenId: BigNumberish | null,
      owner: null,
      _uri: null
    ): EventFilter;

    TokenURIUpdated(
      _tokenId: BigNumberish | null,
      owner: null,
      _uri: null
    ): EventFilter;
  };

  estimateGas: {
    acceptBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<BigNumber>;

    "acceptBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<BigNumber>;

    checkLandAttach(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "checkLandAttach(uint256,address)"(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    listTransfer(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: Overrides
    ): Promise<BigNumber>;

    "listTransfer(uint256,address)"(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: Overrides
    ): Promise<BigNumber>;

    mint(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<BigNumber>;

    "mint(tuple,tuple)"(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<BigNumber>;

    removeAsk(tokenId: BigNumberish, overrides?: Overrides): Promise<BigNumber>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<BigNumber>;

    removeBid(tokenId: BigNumberish, overrides?: Overrides): Promise<BigNumber>;

    "removeBid(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<BigNumber>;

    revokeApproval(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<BigNumber>;

    "revokeApproval(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<BigNumber>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides
    ): Promise<BigNumber>;

    "setAsk(uint256,tuple)"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides
    ): Promise<BigNumber>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<BigNumber>;

    "setBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<BigNumber>;

    tokenMetadataURI(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    "tokenMetadataURI(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    updateTokenLands(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: Overrides
    ): Promise<BigNumber>;

    "updateTokenLands(uint256,uint256[])"(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: Overrides
    ): Promise<BigNumber>;

    updateTokenMetadataURI(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: Overrides
    ): Promise<BigNumber>;

    "updateTokenMetadataURI(uint256,string)"(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: Overrides
    ): Promise<BigNumber>;

    updateTokenURI(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: Overrides
    ): Promise<BigNumber>;

    "updateTokenURI(uint256,string)"(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: Overrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    acceptBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "acceptBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    checkLandAttach(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "checkLandAttach(uint256,address)"(
      tokenId: BigNumberish,
      sender: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    listTransfer(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "listTransfer(uint256,address)"(
      tokenId: BigNumberish,
      recipient: string,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    mint(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "mint(tuple,tuple)"(
      data: {
        tokenURI: string;
        metadataURI: string;
        contentHash: BytesLike;
        metadataHash: BytesLike;
        isPublic: boolean;
        lands: BigNumberish[];
      },
      bidShares: {
        prevOwner: { value: BigNumberish };
        creator: { value: BigNumberish };
        owner: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    removeAsk(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "removeAsk(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    removeBid(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "removeBid(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    revokeApproval(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "revokeApproval(uint256)"(
      tokenId: BigNumberish,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    setAsk(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "setAsk(uint256,tuple)"(
      tokenId: BigNumberish,
      ask: { amount: BigNumberish; currency: string },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    setBid(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "setBid(uint256,tuple)"(
      tokenId: BigNumberish,
      bid: {
        amount: BigNumberish;
        currency: string;
        bidder: string;
        recipient: string;
        sellOnShare: { value: BigNumberish };
      },
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    tokenMetadataURI(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    "tokenMetadataURI(uint256)"(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    updateTokenLands(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "updateTokenLands(uint256,uint256[])"(
      tokenId: BigNumberish,
      lands: BigNumberish[],
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    updateTokenMetadataURI(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "updateTokenMetadataURI(uint256,string)"(
      tokenId: BigNumberish,
      metadataURI: string,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    updateTokenURI(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;

    "updateTokenURI(uint256,string)"(
      tokenId: BigNumberish,
      tokenURI: string,
      overrides?: Overrides
    ): Promise<PopulatedTransaction>;
  };
}
